"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const signaling_1 = require("@phosphor/signaling");
class WidgetRegistry {
    /**
     *
     */
    constructor() {
        this._data = [];
        this._disposed = false;
        this._registered = new signaling_1.Signal(this);
    }
    get registered() {
        return this._registered;
    }
    register(data) {
        this._data.push(data);
        this._registered.emit(data);
    }
    get data() {
        return this._data;
    }
    dispose() {
        // Do nothing if the widget is already disposed.
        if (this.isDisposed) {
            return;
        }
        this._disposed = true;
        this._data = [];
        // Clear the extra data associated with the widget.
        signaling_1.Signal.clearData(this);
    }
    /**
     * Test whether the widget has been disposed.
     */
    get isDisposed() {
        return this._disposed;
    }
}
exports.WidgetRegistry = WidgetRegistry;
//# sourceMappingURL=registry.js.map