"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __await = (this && this.__await) || function (v) { return this instanceof __await ? (this.v = v, this) : new __await(v); }
var __asyncValues = (this && this.__asyncValues) || function (o) {
    if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");
    var m = o[Symbol.asyncIterator], i;
    return m ? m.call(o) : (o = typeof __values === "function" ? __values(o) : o[Symbol.iterator](), i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i);
    function verb(n) { i[n] = o[n] && function (v) { return new Promise(function (resolve, reject) { v = o[n](v), settle(resolve, reject, v.done, v.value); }); }; }
    function settle(resolve, reject, d, v) { Promise.resolve(v).then(function(v) { resolve({ value: v, done: d }); }, reject); }
};
var __asyncGenerator = (this && this.__asyncGenerator) || function (thisArg, _arguments, generator) {
    if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");
    var g = generator.apply(thisArg, _arguments || []), i, q = [];
    return i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i;
    function verb(n) { if (g[n]) i[n] = function (v) { return new Promise(function (a, b) { q.push([n, v, a, b]) > 1 || resume(n, v); }); }; }
    function resume(n, v) { try { step(g[n](v)); } catch (e) { settle(q[0][3], e); } }
    function step(r) { r.value instanceof __await ? Promise.resolve(r.value.v).then(fulfill, reject) : settle(q[0][2], r); }
    function fulfill(value) { resume("next", value); }
    function reject(value) { resume("throw", value); }
    function settle(f, v) { if (f(v), q.shift(), q.length) resume(q[0][0], q[0][1]); }
};
Object.defineProperty(exports, "__esModule", { value: true });
const services_1 = require("@jupyterlab/services");
const coreutils_1 = require("@jupyterlab/coreutils");
const stream_helpers_1 = require("./stream-helpers");
function connectKernel(kernelId, baseUrl) {
    return __awaiter(this, void 0, void 0, function* () {
        kernelId = kernelId;
        baseUrl = baseUrl || coreutils_1.PageConfig.getBaseUrl();
        const connectionInfo = services_1.ServerConnection.makeSettings({ baseUrl });
        let model = yield services_1.Kernel.findById(kernelId, connectionInfo);
        let kernel = yield services_1.Kernel.connectTo(model, connectionInfo);
        return kernel;
    });
}
exports.connectKernel = connectKernel;
/**
 * Async generator for streaming JSON values from Voila.
 *
 * @param path - The notebook path to pass to Voila
 * @param baseUrl - Optional base URL for the request
 */
function requestVoila(path, baseUrl) {
    return __asyncGenerator(this, arguments, function* requestVoila_1() {
        var e_1, _a;
        baseUrl = baseUrl || coreutils_1.PageConfig.getBaseUrl();
        const settings = services_1.ServerConnection.makeSettings({ baseUrl });
        const response = yield __await(services_1.ServerConnection.makeRequest(coreutils_1.URLExt.join(baseUrl, 'voila', 'render', path), {}, settings));
        if (!response.ok) {
            throw new Error(`${response.status} (${response.statusText})`);
        }
        if (!response.body) {
            throw new Error(`Missing response body (${response.url})`);
        }
        const dataStream = stream_helpers_1.parseJSON(stream_helpers_1.splitStream(stream_helpers_1.textDecode(response.body), '\n'));
        try {
            for (var _b = __asyncValues(stream_helpers_1.streamAsyncIterator(dataStream)), _c; _c = yield __await(_b.next()), !_c.done;) {
                const data = _c.value;
                yield yield __await(data);
            }
        }
        catch (e_1_1) { e_1 = { error: e_1_1 }; }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return)) yield __await(_a.call(_b));
            }
            finally { if (e_1) throw e_1.error; }
        }
    });
}
exports.requestVoila = requestVoila;
//# sourceMappingURL=voila.js.map