import { OutputArea } from '@jupyterlab/outputarea';
import { IRenderMimeRegistry } from "@jupyterlab/rendermime";
import { WidgetRenderer } from '@jupyter-widgets/jupyterlab-manager';
import { ReadonlyJSONValue } from "@phosphor/coreutils";
import { Widget, Layout, PanelLayout } from "@phosphor/widgets";
import { WidgetRegistry } from './registry';
declare class ReplaceLayout<T extends Widget> extends Layout {
    replaceNode(target: HTMLElement, widget: T): void;
    removeWidget(widget: T): void;
    iter(): import("@phosphor/algorithm").IIterator<T>;
    _widgets: T[];
}
export declare class VoilaOutputWidget extends Widget {
    constructor(options?: Widget.IOptions);
    replaceWidgetOutputs(rendermime: IRenderMimeRegistry): void;
    renderers(): IterableIterator<WidgetRenderer>;
    layout: ReplaceLayout<OutputArea>;
}
export declare class VoilaView extends Widget {
    /**
     *
     */
    constructor(notebookPath: string, registry: WidgetRegistry, rendermime: IRenderMimeRegistry);
    populateFromPath(path: string): Promise<void>;
    populateFromGenerator(generator: AsyncIterableIterator<ReadonlyJSONValue>): Promise<void>;
    processHeader(header: VoilaView.HeaderData): Promise<void>;
    addEntry(entry: VoilaView.EntryData): void;
    layout: PanelLayout;
    readonly notebookPath: string;
    readonly rendermime: IRenderMimeRegistry;
    protected readonly registry: WidgetRegistry;
}
export declare namespace VoilaView {
    type HeaderData = {
        kernelId: string;
    };
    type EntryData = {
        source: string;
    };
    function validateEntry(entry: ReadonlyJSONValue): entry is EntryData;
    function isHeader(entry: ReadonlyJSONValue): entry is HeaderData;
}
export {};
